# 
# Qusto spec prevede di scaricare dal web i pacchetti npm necessari con il comando npm sotto.
# Di default mock non consente l'accesso in rete, a meno di usare --enable-network
# O lo abiliti, o ti scarichi prima un paccehtto sorgente con i centenuti che servono (vedi sotto npm).
#

%define		own	asterisk
%define		grp	asterisk
%define		sown	root
%define		sgrp	root
%define		rawname	ucp

Name:		freepbx-%{rawname}
Version:	16.0.38.2
Release:	1%{?dist}
Summary:	User Control Panel

License:	See Freepbx Readme
Source0:	https://mirror.freepbx.org/modules/packages/%{rawname}/%{rawname}-%{version}.tgz
Patch0: 	freepbx-ucp-nochown_16.0.20.patch
Patch1: 	freepbx-ucp-nodeAndLinks.patch
Patch2: 	freepbx-ucp-dochowns.patch
Patch3: 	freepbx-ucp-baseurl.patch
# Proviamo a togliere questa patch e a richiedere certman. Poi vedremo.
Patch10: 	freepbx-ucp-noCertman.patch
# On RHEL9 we have node 16 which is incompatible with the outdated mariasql npm module.
# This patch from freepbx-17 switches it with mariadb npm module.
# https://github.com/FreePBX/ucp/commit/1f95376b64558ae707920d9ccb5084deaf09f53b 
Patch100: freepbx-ucp-17.patch

Requires:	freepbx-userman >= 16.0.18
Requires:	freepbx-core >= 16.0.56.4
Requires:	freepbx-pm2 >= 16.0.4
Requires:	freepbx-certman >= 16.0.13
BuildRequires:	npm
BuildRequires:	python3

Provides:	freepbx-%{rawname} = %{version}-%{release}

#BuildArch:	noarch	# Contiene il compilato di mariasql, client node x mariadb

%description
The user control panel is a way for users to control call handling and personal settings from a web browser.

%prep
%setup -q -n %{rawname}
%patch0 -p1
%patch1 -p1
%patch2 -p1
#%patch3 -p1
#%patch10 -p1
%if 0%{?rhel} >8
%patch100 -p1
%endif

# Controlliamo la eventuale presenza di particolarita' da gestire
for ddd in agi-bin bin sbin etc astetc images sounds moh ; do
	[ -e $ddd ] && echo presente $ddd, va gestito && exit 1
done

# Non mi va di lanciare gpg a destra e a manca, solo per venire a sapere che ho modificato i moduli
%{__rm} module.sig

# Delete backup files
find . -name '*.orig' -exec rm '{}' ';'
find . -depth -name '.git*' -exec rm -rf '{}' ';'

# fix dir perms
find . -type d -exec chmod 755 '{}' ';'
find . -type f -exec chmod 644 '{}' ';'
#find . -type f -regex '.*\.\(php\|html\)$' -exec chmod 644 '{}' ';'

echo -n 'prefix = "~/.node"' > node/.npmrc
/bin/bash -c 'cd node &&
mkdir -p .pm2 &&
mkdir -p logs &&
export HOME=$PWD &&
export PM2_HOME=$HOME/.pm2 &&
export ASTLOGDIR=/var/log/asterisk &&
export ASTVARLIBDIR=/usr/share/asterisk &&
export PATH=$HOME/.node/bin:$PATH &&
export NODE_PATH=$HOME/.node/lib/node_modules:$NODE_PATH &&
export MANPATH=$HOME/.node/share/man:$MANPATH &&
echo "+ npm install -g npm-cache" &&
npm install -g npm-cache --loglevel verbose &&
echo "+ npm-cache -v" &&
npm-cache -v &&
echo "+ npm-cache install --only=production" &&
npm-cache install --only=production
'

# Delete cache and other metaresults I think are not needed
rm -rf node/{.package_cache,.npm}
rm -rf node/.node	# Vediamo se corretto, mi sembrano tutte cache. La distro lo mette in ~/asterisk, ma suppongo xche loro fanno build li'
rm -rf node/.cache	# Vediamo se corretto, mi sembrano tutte cache. La distro lo mette in ~/asterisk, ma suppongo xche loro fanno build li'
rmdir node/.pm2		# Mi pare non serva

# Correggiamo i percorsi - verificare che alla fine sia coerente con il dove li metteremo
#find node/.node/lib/node_modules node/node_modules -type f -exec perl -pi -e 's-/home/builder/rpmbuild/BUILD/%{rawname}/node-/usr/share/freepbx/admin/modules/%{rawname}/node-' '{}' ';'
# Non sto a richiedere + perl da quando uso mock: sed lo ho gia', prob e' nella dotazione standard
#find node/node_modules -type f -exec perl -pi -e 's-/home/builder/rpmbuild/BUILD/%{rawname}/node-/usr/share/freepbx/admin/modules/%{rawname}/node-' '{}' ';'
find node/node_modules -type f -exec sed -i -e 's-/builddir/build/BUILD/%{rawname}/node-/usr/share/freepbx/admin/modules/%{rawname}/node-' '{}' ';'

# Correggiamo uno shabang in alcuni file di test, che vorrebbero un programma che al limite, dovrebbe trovarsi nel medesimo ambiente node.
#find node/node_modules/performance-now/test/scripts -name '*.coffee' -type f -exec perl -ni -e '$. == 1 and m|^#!/usr/bin/env \./node_modules/.bin/coffee\s*$| or print'  '{}' ';'
#find node/node_modules/performance-now/test/scripts -name '*.coffee' -type f -exec awk -i inplace '{if (NR==1 && /^#!\/usr\/bin\/env \.\/node_modules\/\.bin\/coffee/) {next}; print}' '{}' ';'
# equivalente con meno '\'
find node/node_modules/performance-now/test/scripts -name '*.coffee' -type f -exec awk -i inplace '{if (NR==1 && match($0, "^#!/usr/bin/env \\./node_modules/\\.bin/coffee")) {next}; print}' '{}' ';'

#perl -ni -e 'next if 1 .. m|^cat\b|; last if m|^EOF$|; print' hooks/logrotate
sed -i '1,/^cat /d;/^EOF$/,$d' hooks/logrotate
# Semplice metodo x accorgermi, fallendo qualora vengano introdotti nuovi hooks da gestire
%{__mkdir} etclogrotate.d
%{__mv} hooks/logrotate etclogrotate.d/freepbx-ucp
rmdir hooks

%install
%{__install} -d %{buildroot}%{_sysconfdir}/logrotate.d
%{__install} -m0644 etclogrotate.d/freepbx-ucp %{buildroot}%{_sysconfdir}/logrotate.d/

# Nel pacchetto originale, c'era un chown 0775 su tutta la dir ucp. Non so se vorra' scriverci qualcosa. Vedremo.
%{__install} -d %{buildroot}%{_datadir}/freepbx/admin/assets
%{__ln_s} %{_datadir}/freepbx/admin/modules/%{rawname}/assets %{buildroot}%{_datadir}/freepbx/admin/assets/%{rawname}

%{__install} -d %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}
%{__cp} -aR `ls | egrep -v '^(agi-bin|bin|etc|sounds|moh|images|LICENSE|README.md)'` %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}
%{__install} -d %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}/node/logs

%preun
# Cerchiamo, per quanto possibile, di lasciare in giro poche schifezze:
# In htdocs/includes/UCP.class.php sono dichiarate le cache
# $cache = dirname(__DIR__).'/assets/js/compiled/main';
# $cache = dirname(__DIR__).'/assets/css/compiled/main';
# mentre in htdocs/includes/Modules.class.php sono dichiarate le cache
# $cache = dirname(__DIR__).'/assets/js/compiled/modules';
# $cache = dirname(__DIR__).'/assets/css/compiled/modules';
find %{_datadir}/freepbx/admin/modules/%{rawname}/assets/{css,js} -depth -maxdepth 1 -type d -name compiled -exec rm -rf '{}' ';'

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%doc README.md
%defattr(0644,%{sown},%{sgrp},0755)

%attr(0644,%{sown},%{sgrp}) %config(noreplace) %{_sysconfdir}/logrotate.d/*

%{_datadir}/freepbx/admin/assets/*
%{_datadir}/freepbx/admin/modules/%{rawname}
%attr(0755,%{own},%{grp}) %{_datadir}/freepbx/admin/modules/%{rawname}/node/logs
# Qui dobbiamo linkare le dir ucp degli altri moduli
# Va notato che nella freepbx distro, i link hanno iniziale maiuscola, ad es Cdr -> /var/www/html/admin/modules/cdr/ucp
%attr(0755,%{own},%{grp}) %{_datadir}/freepbx/admin/modules/%{rawname}/htdocs/modules

%changelog
* Wed Jul 17 2024 Luigi Iotti <asterisk@iotti.biz> - 16.0.38.2
- Updated version

* Thu Oct 05 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.38.1
- Updated version

* Sun Apr 16 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.38
- Minor cleanup

* Mon Apr 03 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.38
- Updated version

* Sat Mar 18 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.36
- Updated version

* Wed Feb 15 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.33
- Updated version

* Thu Feb 09 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.32
- Updated version

* Mon Dec 26 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.30
- Updated version

* Mon Dec 05 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.28
- Updated version

* Wed Sep 07 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.27
- Updated version

* Tue Aug 30 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.26
- Updated version

* Tue Aug 09 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.22
- Updated version

* Tue Jun 14 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.21
- Updated version

* Wed Jun 01 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.20
- Updated version

* Mon Mar 07 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.19
- Updated version

* Wed Feb 09 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.18
- Updated version

* Tue Jan 25 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.17
- Initial build
